/*
  
     memP Heap Profiler ( http://memp.sourceforge.net/ )
  
     Please see COPYRIGHT AND LICENSE information at the end of this file.
  
     ----- 
  
     memPi_proto.h
  
     $Id: memPi_proto.h 369 2006-10-05 19:21:12Z chcham $

*/

extern int open_dwarf_executable (char *fileName);
extern void close_dwarf_executable (void);
extern void memPi_msg (char *fmt, ...);
extern void memPi_abort (char *fmt, ...);
extern void memPi_msg_debug (char *fmt, ...);
extern void memPi_msg_warn (char *fmt, ...);
extern void memPi_msg_debug0 (char *fmt, ...);
extern void memPi_msg_debug_level (int level, char *fmt, ...);

extern int memP_record_traceback (void *pc_array[], int max_stack);
extern memP_TIMER memP_gettime (void);
extern char *memP_get_executable_name (void);
extern char *memP_format_address (void *pval, char *addr_buf);
extern h_t *h_open (int size, h_HashFunct hf, h_Comparator hc);
extern void h_close (h_t * ht);
extern int h_count (h_t * ht);
extern int h_insert (h_t * ht, void *ptr);
extern void *h_search (h_t * ht, void *key, void **ptr);
extern void *h_delete (h_t * ht, void *key, void **ptr);
extern int h_gather_data (h_t * ht, int *ac, void ***ptr);
extern void memPi_init (char *appName);
extern int callsite_pc_cache_comparator (const void *p1, const void *p2);
extern unsigned int callsite_pc_cache_hashkey (const void *p1);
extern int memPi_query_pc (void *pc, char **filename, char **functname,
                           unsigned int *lineno);
extern int callsite_src_id_cache_comparator (const void *p1, const void *p2);
extern unsigned int callsite_src_id_cache_hashkey (const void *p1);
extern int memPi_query_src (callsite_stats_t * p);
extern int memPi_mergeResults (void);
extern void memPi_publishResults (int report_style);
extern void memPi_collect_basics (void);
extern void memPi_generateReport (int report_style);
extern void memPi_finalize (void);
extern callsite_stats_t *memPi_update_callsite_stats (unsigned op,
                                                      int rank,
                                                      void **pc, double dur,
                                                      double sendSize,
                                                      double ioSize);
extern char *memPdemangle (const char *mangledSym);
extern int memP_find_src_loc (void *i_addr_hex, char **o_file_str,
                              unsigned int *o_lineno, char **o_funct_str);
extern int open_bfd_executable (char *filename);
extern void close_bfd_executable (void);
extern int MPI_Pcontrol (const int flag, ...);
extern int mpi_pcontrol_ (int *flag, ...);
extern double calc_COV (double *data, int dataSize);
extern void memPi_profile_print (FILE * fp, int report_style);
extern void memPi_profile_print_verbose (FILE * fp);
extern void memPi_profile_print_concise (FILE * fp);
extern char *GetBaseAppName (char *rawName);
extern int memPi_RecordTraceBack (jmp_buf jb, void *pc_array[], int max_back);
extern void memPi_getenv (void);
extern char *getProcExeLink (void);
extern void getProcCmdLine (int *ac, char **av);
extern void memPi_copy_args (int *ac, char **av, int av_len);
extern void memPi_copy_given_args (int *ac, char **av, int av_len, int argc,
                                   char **argv);
extern unsigned long long memPi_get_text_start (char *filename);
extern void memPi_print_callsite_time_info (FILE * fp);
extern void memPi_print_all_callsite_time_info (FILE * fp);
extern void memPi_print_concise_callsite_time_info (FILE * fp);
extern void memPi_print_callsite_sent_info (FILE * fp);
extern void memPi_print_all_callsite_sent_info (FILE * fp);
extern void memPi_print_concise_callsite_sent_info (FILE * fp);
extern void memPi_print_task_info (FILE * fp, int report_style);
extern void memPi_print_verbose_task_info (FILE * fp);
extern void memPi_print_concise_task_info (FILE * fp);
extern void *memPi_find_interpose_symbol (const char *inter_str);
extern void *memPi_malloc (size_t);
extern void *memPi_calloc (size_t, size_t);
extern void *memPi_realloc (void *, size_t);
extern void memPi_free (void *);
extern void memPi_profile_print_xml_verbose (FILE * fp);
extern char *memPi_escape_xml_chars (const char *xml_buf);
extern void memPi_profile_print_task_xml_verbose (void);
extern int memPi_verify_unanimous (int inval);
extern int memPi_open_executable (char *);
extern void memPi_close_executable ();
extern void memPi_print_stack (void **pc_array);
extern void memPi_open_alloc_hash ();
extern void memPi_update_task_stats (size_t allocSize, size_t freeSize,
                                     callsite_stats_t * csp, unsigned int op);
extern unsigned int memPi_callsite_stats_pc_hashkey (const void *p);
extern int memPi_callsite_stats_pc_comparator (const void *p1,
                                               const void *p2);
extern unsigned int memPi_callsite_stats_src_hashkey (const void *p);
extern int memPi_callsite_stats_src_comparator (const void *p1,
                                                const void *p2);
extern unsigned int memPi_callsite_stats_src_id_hashkey (const void *p);
extern int memPi_callsite_stats_src_id_comparator (const void *p1,
                                                   const void *p2);
extern int callsite_pc_cache_comparator (const void *p1, const void *p2);
extern unsigned int callsite_pc_cache_hashkey (const void *p1);
extern int callsite_src_id_cache_comparator (const void *p1, const void *p2);
extern unsigned int callsite_src_id_cache_hashkey (const void *p1);
extern int memPi_insert_callsite_records (callsite_stats_t * p);
extern callsite_stats_t *memPi_get_callsite (unsigned int op, int rank,
                                             void **pc);
extern void memPi_set_internal_functions ();
extern int memPi_get_stack_trace (void *pc_array[]);
extern void memPi_insert_alloc_ptr (h_t * ht, void *retval, size_t msz,
                                    alloc_stats_t * as,
                                    callsite_stats_t * csp);
extern size_t memPi_delete_alloc_ptr (h_t * ht, void *inptr,
                                      alloc_stats_t * as);
extern void print_mallinfo ();

extern void memPi_set_nonmpi_values ();

/*
  
<license>

Copyright (c) 2010, Lawrence Livermore National Security, LLC.
Produced at the Lawrence Livermore National Laboratory
Written by Christopher Chambreau <chcham@llnl.gov>.
CODE-OCEC-10-010
All rights reserved.

This file is part of memP. For details, see http://memp.sourceforge.net .
Please also read this link – Additional BSD Notice.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

  o  Redistributions of source code must retain the above copyright notice, 
     this list of conditions and the disclaimer below.

  o  Redistributions in binary form must reproduce the above copyright notice, 
     this list of conditions and the disclaimer (as noted below) in the 
     documentation and/or other materials provided with the distribution.

  o  Neither the name of the LLNS/LLNL nor the names of its contributors may be
     used to endorse or promote products derived from this software without 
     specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND
CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL LAWRENCE LIVERMORE NATIONAL
SECURITY, LLC, THE U.S. DEPARTMENT OF ENERGY OR CONTRIBUTORS BE
LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
THE POSSIBILITY OF SUCH DAMAGE.


Additional BSD Notice

1. This notice is required to be provided under our contract with the U.S.
Department of Energy (DOE). This work was produced at Lawrence Livermore
National Laboratory under Contract No. DE-AC52-07NA27344 with the DOE.

2. Neither the United States Government nor Lawrence Livermore National
Security, LLC nor any of their employees, makes any warranty, express or
implied, or assumes any liability or responsibility for the accuracy,
completeness, or usefulness of any information, apparatus, product, or process
disclosed, or represents that its use would not infringe privately-owned rights.

3. Also, reference herein to any specific commercial products, process, or
services by trade name, trademark, manufacturer or otherwise does not
necessarily constitute or imply its endorsement, recommendation, or favoring by
the United States Government or Lawrence Livermore National Security, LLC.
The views and opinions of authors expressed herein do not necessarily state or
reflect those of the United States Government or Lawrence Livermore National
Security, LLC, and shall not be used for advertising or product endorsement
purposes.

</license>
  
*/
